;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |
;   $ Purebasic Extras           $                                 
;   $(C) by Bluespeed            $
;   $ bluespeedde@yahoo.de       $
;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |




;  ---------------------------------------------------------------------------------
;                            DIE PUREBASIC EXTRAS
;  ---------------------------------------------------------------------------------

;  Hallo und Willkommen zum 10. und letzten Teil der Tutorial Reihe von Purebasic. Heute werden 
;  wir uns mal die zur Verfuegung gestellten Effekte von PB ansehen. Natuerlich werde ich nicht alle
;  Grafik-Effekte hier programmieren. Der Code selber waere nicht sehr lang, doch die ganzen Kommentare
;  und Erklaerungen wuerden Euch verwirren. Deshalb code ich nur zwei von den Grafik-Effekten. 

; Wir muessen vorher noch etwas initialisieren, da wir ein Vollbild erstellen und dies braucht DirectX.
If InitSprite() = 0                                               ; Wenn wir die Sprite Funktion nicht initialisieren koennen,
  MessageRequester("Fehler","Konnte dx nicht finden",0)           ; wird ein Fehler gemeldet, der die moegliche Ursache ausgibt.
EndIf                                                             ; Ende der Abfrage

; Nun wollen wir auch die Escape Taste benutzen. Das uebernimmt nun auch DirectX (DirectInput).
If InitKeyboard()=0                                               ; Wenn wir die Keyboard Funktion nicht initialisieren koennen,
  MessageRequester("Fehler","Konnte dx nicht finden",0)           ; wird ein Fehler gemeldet, der die moegliche Ursache ausgibt.
EndIf                                                             ; Ende der Abfrage

; Jetzt wollen wir den Vollbild Modus erstellen.
If OpenScreen(800,600,32,"Vollbild") = 0                          ; Wenn "Oeffne ein Vollbild" aus ist,
  MessageRequester("Fehler","Konnte kein Vollbild erstellen ",0)  ; wird eine Fehlermeldung ausgegeben.
EndIf                                                             ; Ende der Abfrage


LoadSprite(0,"files/hgrund.bmp",#PB_Sprite_Memory)       ; Wir laden ein Hintergrundsprite, das in den Hauptspeicher gespeichert wird (fuer Spezial-Effekte).
LoadSprite(1,"files/icon.bmp",#PB_Sprite_Memory)         ; Wir laden eine Iconbild, das in den Hauptspeicher gespeichert wird (fuer Spezial-Effekte).

Filterpos = 0                                            ; Varibale Filterpos auf 0 setzen.
TranparentWert = 0                                       ; Varibale TransparentWet auf 0 setzen.

Repeat                                                   ; Eine Schleife wird gestartet...
  FlipBuffers()                                          ; Wir wechseln die Buffer
  ClearScreen(0,0,0)                                     ; Der Screen wird mit der Farbe schwarz gesaeubert.
  ExamineKeyboard()                                      ; Befehl, um die Tastaturabfrage funktionstuechtig zu machen.

  StartSpecialFX()                                       ; Wir muessen diesen Befehl eingeben, um die Extras von Purebasic nutzen zu koennen.
  DisplaySprite(0,0,0)                                   ; Das geladene Hintergrundbild wird auf der Position 0,0 angezeigt.

;------------------------ TRANSLUCIDE -----------------------------------------

  TransparentWert + 3                                    ; Wir erhoehen den TransparentWert um 3. D.h. es wird um 3 Werte undurchsichtiger.
  DisplayTranslucideSprite(1,200,200,TransparentWert)    ; Wir zeichnen das geladene Icon als TranslucideSprite(Sprite,X,Y,INTENSITAET) 
;-------------------------------------------------------------------------------

;------------------------ RGB FILTER -------------------------------------------
  Filterpos + 4                                          ; Wir bewegen den Filter um 4 Pixel.
  If Filterpos > 800                                     ; Wenn der Filter ueber den Bildschirmrand geht,
    Filterpos = -300                                     ; wird er auf -300 positioniert.
  EndIf                                                  ; Ende der Abfrage

 DisplayRGBFilter(Filterpos  , 200, 100, 100, 255, 0, 0)     ; Wir zeichnen einen Farbfilter  DisplayRGBFilter(x,y,Breite,Hoehe,Rot,Gruen,Blau).
 DisplayRGBFilter(Filterpos+150, 200, 100, 100, 0, 255, 0)   ; Wir zeichnen einen zweiten Farbfilter DisplayRGBFilter(x,y,Breite,Hoehe,Rot,Gruen,Blau).
;------------------------------------------------------------------------------- 
StopSpecialFX()                                          ; Wir beenden die Spezial-Effekte.


  If KeyboardPushed(#PB_Key_Escape)                      ; Wenn die Taste Escape gedrueckt wird,
    End                                                  ; wird das Programm beendet.
  EndIf                                                  ; Ende der Abfrage
ForEver                                                  ; Unendlicher Schleifendurchlauf

; Also ich kann euch sagen: kein einziger Purebasic Grafikbefehl nimmt mehr als 8 Zeilen Code ^_^. Translucide - was ist das ueberhaupt??
; Manche Leute bezeichnen es auch als Alpha-Blending. Es ist ein Grafik-Effekt, der von z.B. nicht sichtbar (voellig transparent) bis zu 
; undurchsichtig ueberwechselt. Mit diesem Code lassen sich sehr schoene Tricks fuer Games programmieren. Schauen wir uns doch einfach
; mal die 0-255 Werte an. Wozu dienen sie? Euch sind sicher die Grundfarben bekannt: R,G,B (Rot,Gruen,Blau). Diese Farben reichen 
; von 0 (schwarz) bis 255 (Rot,Gruen oder Blau). Wenn wir z.B. 0,0,255 angegeben haben, dann wissen wir, dass diese Farbe blau ist.
; Wuerden wir in der mitte 255 stehen haben, waere es die Farbe gruen. Natuerlich kann man auch Werte zwichen 0-255 nehmen, wie 128. 
; Alle werte zwischen 0-255 sind moeglich. Die Transparenzwerte gehen ebenfalls von 0 (voellig transparent) bis 255 (undurchsichtig).
; Wir deklarieren eine Varibale (TransparentWert), die auf 0 steht, also voellig transparent. Danach erhoehen wir ihren den Wert um 3.
; Da wir dies in einer Schleife schreiben, wiederholt sich dieser Vorgang, bis er an der 255 Grenze ankommt. Dann sorgt der Befehl
; DisplayTranslucideSprite(), der auch eingegeben werden muss, um diesen transparenten Uebergang moeglich zu machen, dafuer, dass der
; Vorgang bei 255 stoppt, da dann das Sprite voellig undurchsichtig ist.


; Nun kommen wir zu dem RGB Filter. Dieser dient dazu, um mit einer frei waehlbaren Farbe ueber irgendwas drueber zu fahren. Dabei wird
; die Farbe an der Position des RGB-Filters in die RGB-Farbe umgewandelt. Wenn er nicht mehr auf dieser Position ist, wird wieder die
; alte Farbe eingeschaltet.
; Wir haben eine Filterpos Variable definiert. Diese ist dazu da, um den Filter zu bewegen. Wir bewegen mit Hilfe der Variable Filterpos
; den Filter. Wenn der Filter ueber den Bildschirmrand geht, wird er einfach wieder zurueckgestellt. DisplayRGBFilter() muss eingegeben
; werden, wenn man diesen Effekt nutzen moechte.   
  

; So Leute - das war mein Einstiegs-Kurs fuer Euch. Wie ihr sicher schon bemerkt habt, nuetzt alleine das Lesen nicht allzuviel, um
; so etwas zu verstehen. Mein Tipp an Euch: spielt einfach damit rum. Versucht die einzelnen Befehle zu verstehen, WAS IST IHRE AUFGABE? 
; WAS FUER ANGABEN BRAUCHE ICH?  WANN KANN MAN SIE EINGEBEN (bei manchen Sachen wie Endif oder Else) und ganz wichtig CODEN CODEN CODEN.
; Auch wenn Purebasic eine enfache Programmiersprache ist, man muss erst den Syntax verstehen. Doch dann wenn ihr es am wenigsten erwartet,
; macht es BLINK und alles laeuft ohne Probleme. Wenn ihr irgendwelche Fragen habt, postet einfach im www.Purebasic.de Forum. 

; CU 
; BLUESPEED
; ExecutableFormat=Windows
; FirstLine=1
; Executable=D:\Numan\Projekte\Tutorials\Tutorial9.exe
; DisableDebugger
; EOF